/*
 * DO NOT EDIT THIS FILE - it is generated by Glade.
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <string.h>

#include <gdk/gdkkeysyms.h>
#include <gtk/gtk.h>
#include <gphoto2.h>

#include "globals.h"
#include "gtkiconlist.h"
#include "callbacks.h"
#include "interface.h"
#include "support.h"
#include "util.h"

void hide_progress_window (GtkWidget *widget, gpointer data) {
 
        gtk_widget_hide(gp_gtk_progress_window);
        idle();
} 

GtkWidget*
create_save_window (int directory_only)
{

  GtkWidget *save_window, *hbox, *frame, *photos, *thumbs, *override,
	    *label, *prefix, *program;
  GtkTooltips *tooltip;
  GList *child;
  char buf[1024];

  save_window = gtk_file_selection_new ("Save selected photos...");
  gtk_object_set_data (GTK_OBJECT (save_window), "main_window", save_window);
  gtk_window_set_title (GTK_WINDOW (save_window), _("Save selected photos..."));
  gtk_window_set_position (GTK_WINDOW (save_window), GTK_WIN_POS_CENTER);
  gtk_window_set_modal (GTK_WINDOW (save_window), TRUE);
  gtk_window_set_default_size (GTK_WINDOW (save_window), 450, 400);
  if (gp_setting_get("gtkam", "cwd", buf)==GP_OK)
	  gtk_file_selection_set_filename(GTK_FILE_SELECTION(save_window),buf);

  frame = gtk_frame_new("What to save:");
  gtk_widget_ref(frame);
  gtk_object_set_data_full (GTK_OBJECT (save_window), "frame", frame,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show(frame);
  gtk_box_pack_start(GTK_BOX(GTK_FILE_SELECTION(save_window)->main_vbox), 
	frame, FALSE, FALSE, 0);

  hbox = gtk_hbox_new(TRUE, 5);
  gtk_widget_ref(hbox);
  gtk_object_set_data_full (GTK_OBJECT (save_window), "save_which_hbox", hbox,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show(hbox);
  gtk_container_add(GTK_CONTAINER(frame), hbox);

  photos = gtk_check_button_new_with_label("Save Photos");
  gtk_widget_ref(photos);
  gtk_object_set_data_full (GTK_OBJECT (save_window), "save_photos", photos,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show(photos);
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(photos), TRUE);
  tooltip = gtk_tooltips_new();
  gtk_tooltips_set_tip (tooltip, photos, 
	_("Photos will be saved if this is checked."), NULL);
  gtk_box_pack_start(GTK_BOX(hbox), photos, TRUE, TRUE, 0);

  thumbs = gtk_check_button_new_with_label("Save Thumbnails");
  gtk_widget_ref(thumbs);
  gtk_object_set_data_full (GTK_OBJECT (save_window), "save_thumbs", thumbs,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show(thumbs);
  tooltip = gtk_tooltips_new();
  gtk_tooltips_set_tip (tooltip, thumbs, 
	_("Thumbnails will be saved if this is checked."), NULL);
  gtk_box_pack_start(GTK_BOX(hbox), thumbs, TRUE, TRUE, 0);

  hbox = gtk_hbox_new(FALSE, 0);
  gtk_widget_ref(hbox);
  gtk_object_set_data_full (GTK_OBJECT (save_window), "hboxblah", hbox,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show(hbox);
  gtk_box_pack_start(GTK_BOX(GTK_FILE_SELECTION(save_window)->main_vbox),hbox,
    TRUE, TRUE, 0);

  label = gtk_label_new("Open image(s) with:");
  gtk_widget_ref(label);
  gtk_object_set_data_full (GTK_OBJECT (save_window), "labelblah", label,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show(label);
  gtk_label_set_justify(GTK_LABEL(label), GTK_JUSTIFY_LEFT);
  gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 0);

  program = gtk_entry_new();
  gtk_widget_ref(program);
  gtk_object_set_data_full (GTK_OBJECT (save_window), "program", program,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show(program);
  gtk_box_pack_start(GTK_BOX(hbox), program, TRUE, TRUE, 0);
  tooltip = gtk_tooltips_new();
  gtk_tooltips_set_tip (tooltip, program, 
	_("Type in the name of the program's executable you want to run. Leave blank for none."), NULL);

  /* Create the filename override button */
  override = gtk_check_button_new_with_label("Use the filenames provided by the camera");
  gtk_widget_ref(override);
  gtk_object_set_data_full (GTK_OBJECT (save_window), "use_camera_filename", override,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show(override);
  gtk_box_pack_start(GTK_BOX(GTK_FILE_SELECTION(save_window)->main_vbox),override,
    TRUE, TRUE, 0);
  tooltip = gtk_tooltips_new();
  gtk_tooltips_set_tip (tooltip, override,
	_("Choose whether to use the filename provided by the camera"), NULL);
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(override), TRUE);
  gtk_widget_set_sensitive(GTK_FILE_SELECTION(save_window)->selection_entry, FALSE);
  gtk_signal_connect(GTK_OBJECT(override), "clicked",
   GTK_SIGNAL_FUNC(toggle_sensitivity), GTK_FILE_SELECTION(save_window)->selection_entry);

  if (directory_only) {
	gtk_widget_hide(GTK_FILE_SELECTION(save_window)->selection_entry);
        gtk_widget_hide(GTK_FILE_SELECTION(save_window)->selection_text);
        /* Hide the file selection list (only show directory listing */
        child = gtk_container_children( 
        	GTK_CONTAINER(GTK_FILE_SELECTION(save_window)->main_vbox));
        /* get the dir/file list box children */
        child = gtk_container_children(
                GTK_CONTAINER(child->next->next->data));
        gtk_widget_hide(GTK_WIDGET(child->next->data));

        /* Create the hbox to hold the filename prefix label and entry */
        hbox = gtk_hbox_new(FALSE, 5);
	gtk_widget_ref(hbox);
        gtk_object_set_data_full (GTK_OBJECT (save_window), "hbox", 
		hbox, (GtkDestroyNotify) gtk_widget_unref);
        gtk_widget_show(hbox);
        gtk_box_pack_start(GTK_BOX(GTK_FILE_SELECTION(save_window)->main_vbox),hbox,
                TRUE, TRUE, 0);
        gtk_box_reorder_child(GTK_BOX(GTK_FILE_SELECTION(save_window)->main_vbox),
                hbox, 256);

        gtk_signal_connect(GTK_OBJECT(override), "clicked",
                GTK_SIGNAL_FUNC(toggle_sensitivity), hbox);

        label = gtk_label_new("Filename prefix:");
	gtk_widget_ref(label);
        gtk_object_set_data_full (GTK_OBJECT (save_window), "prefix_label", 
		label, (GtkDestroyNotify) gtk_widget_unref);
        gtk_widget_show(label);
        gtk_box_pack_start(GTK_BOX(hbox),label, FALSE, FALSE, 0);

        prefix = gtk_entry_new();
	gtk_widget_ref(prefix);
        gtk_object_set_data_full (GTK_OBJECT (save_window), "prefix", 
		prefix, (GtkDestroyNotify) gtk_widget_unref);
        gtk_widget_show(prefix);
        gtk_box_pack_start(GTK_BOX(hbox), prefix, TRUE, TRUE, 0);
        gtk_widget_set_sensitive(hbox, FALSE);
  }

  return (save_window);
}

GtkWidget*
create_main_window (void)
{
/* __main */
  /* widget labels: "folder_tree" "icons" "status_bar" "notebook"
		    "camera_tree" "camera_pixmap" "camera_tree" "use_thumbs"
  */

  GtkWidget *main_window;
  GtkWidget *vbox1;
  GtkWidget *hbox;
  GtkWidget *pixmap;
  GtkWidget *label;
  GtkWidget *menubar1;
  GtkTooltips *tooltip;
  guint tmp_key;
  GtkWidget *file2;
  GtkWidget *file2_menu;
  GtkAccelGroup *file2_menu_accels;
/*
  GtkWidget *open3;
*/
  GtkWidget *save1;
/*
  GtkWidget *separator2;
  GtkWidget *export1;
  GtkWidget *export1_menu;
  GtkAccelGroup *export1_menu_accels;
  GtkWidget *html_gallery1;
*/
  GtkWidget *separator5;
  GtkWidget *exit1;
  GtkWidget *edit1;
  GtkWidget *edit1_menu;
  GtkAccelGroup *edit1_menu_accels;
  GtkWidget *select1;
  GtkWidget *select1_menu;
  GtkAccelGroup *select1_menu_accels;
  GtkWidget *all1;
  GtkWidget *inverse1;
  GtkWidget *none1;
  GtkWidget *camera1;
  GtkWidget *camera1_menu;
  GtkAccelGroup *camera1_menu_accels;
  GtkWidget *select2;
  GtkWidget *separator6;
/*
  GtkWidget *download_selected1;
  GtkWidget *download_selected1_menu;
  GtkAccelGroup *download_selected1_menu_accels;
  GtkWidget *thumbnails2;
  GtkWidget *photos1;
  GtkWidget *both1;
*/
  GtkWidget *delete1;
  GtkWidget *delete1_menu;
  GtkAccelGroup *delete1_menu_accels;
  GtkWidget *selected_photos1;
  GtkWidget *all_images1;
  GtkWidget *separator3;
  GtkWidget *configure1;
  GtkWidget *information1;
  GtkWidget *manual1;
  GtkWidget *about_the_driver1;
  GtkWidget *help1;
  GtkWidget *help1_menu;
  GtkAccelGroup *help1_menu_accels;
  GtkWidget *user_s_manual1;
  GtkWidget *authors1;
  GtkWidget *license1;
  GtkWidget *about_gphoto1;
  GtkWidget *toolbar1;
  GtkWidget *tmp_toolbar_icon;
/*
  GtkWidget *open_button;
*/
  GtkWidget *save_button;
  GtkWidget *refresh_button;
  GtkWidget *delete_button;
  GtkWidget *label2;
  GtkWidget *configure_button;
  GtkWidget *frame;
  GtkWidget *checkbutton;
  GtkWidget *label5;
  GtkWidget *exit_button;
  GtkWidget *hpaned1;
  GtkWidget *vbox2;
  GtkWidget *scrolledwindow1;
  GtkWidget *viewport1;
  GtkWidget *tree1;
  GtkWidget *tree_item;
  GtkWidget *scrolledwindow2;
  GtkWidget *viewport2;
  GtkWidget *icons;
  GtkWidget *status_bar;
  GtkAccelGroup *accel_group;

  accel_group = gtk_accel_group_new ();

  main_window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_object_set_data (GTK_OBJECT (main_window), "main_window", main_window);
  gtk_window_set_title (GTK_WINDOW (main_window), _("gtKam"));
  gtk_window_set_position (GTK_WINDOW (main_window), GTK_WIN_POS_CENTER);
  gtk_window_set_default_size (GTK_WINDOW (main_window), 640, 480);

  vbox1 = gtk_vbox_new (FALSE, 1);
  gtk_widget_ref (vbox1);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "vbox1", vbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox1);
  gtk_container_add (GTK_CONTAINER (main_window), vbox1);

  menubar1 = gtk_menu_bar_new ();
  gtk_widget_ref (menubar1);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "menubar1", menubar1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (menubar1);
  gtk_box_pack_start (GTK_BOX (vbox1), menubar1, FALSE, FALSE, 0);

  file2 = gtk_menu_item_new_with_label ("");
  tmp_key = gtk_label_parse_uline (GTK_LABEL (GTK_BIN (file2)->child),
                                   _("_File"));
  gtk_widget_add_accelerator (file2, "activate_item", accel_group,
                              tmp_key, GDK_MOD1_MASK, 0);
  gtk_widget_ref (file2);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "file2", file2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (file2);
  gtk_container_add (GTK_CONTAINER (menubar1), file2);

  file2_menu = gtk_menu_new ();
  gtk_widget_ref (file2_menu);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "file2_menu", file2_menu,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (file2), file2_menu);
  file2_menu_accels = gtk_menu_ensure_uline_accel_group (GTK_MENU (file2_menu));
/*
  open3 = gtk_menu_item_new_with_label ("");
  tmp_key = gtk_label_parse_uline (GTK_LABEL (GTK_BIN (open3)->child),
                                   _("_Open Photo"));
  gtk_widget_add_accelerator (open3, "activate_item", file2_menu_accels,
				tmp_key, 0, 0);
  gtk_widget_ref (open3);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "open3", open3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (open3);
  gtk_container_add (GTK_CONTAINER (file2_menu), open3);
  gtk_widget_add_accelerator (open3, "activate", accel_group,
                              GDK_o, GDK_CONTROL_MASK,
                              GTK_ACCEL_VISIBLE);
*/
  save1 = gtk_menu_item_new_with_label ("");
  tmp_key = gtk_label_parse_uline (GTK_LABEL (GTK_BIN (save1)->child),
                                   _("_Save Selected Photos..."));
  gtk_widget_add_accelerator (save1, "activate_item", file2_menu_accels,
				tmp_key, 0, 0);
  gtk_widget_ref (save1);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "save1", save1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (save1);
  gtk_container_add (GTK_CONTAINER (file2_menu), save1);
  gtk_widget_add_accelerator (save1, "activate", accel_group,
                              GDK_s, GDK_CONTROL_MASK,
                              GTK_ACCEL_VISIBLE);

/* Will be added 
  separator2 = gtk_menu_item_new ();
  gtk_widget_ref (separator2);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "separator2", separator2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (separator2);
  gtk_container_add (GTK_CONTAINER (file2_menu), separator2);
  gtk_widget_set_sensitive (separator2, FALSE);

  export1 = gtk_menu_item_new_with_label ("");
  tmp_key = gtk_label_parse_uline (GTK_LABEL (GTK_BIN (export1)->child),
                                   _("_Export"));
  gtk_widget_add_accelerator (export1, "activate_item", file2_menu_accels,
                              tmp_key, 0, 0);
  gtk_widget_ref (export1);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "export1", export1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (export1);
  gtk_container_add (GTK_CONTAINER (file2_menu), export1);

  export1_menu = gtk_menu_new ();
  gtk_widget_ref (export1_menu);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "export1_menu", export1_menu,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (export1), export1_menu);
  export1_menu_accels = gtk_menu_ensure_uline_accel_group (GTK_MENU (export1_menu));
  html_gallery1 = gtk_menu_item_new_with_label ("");
  tmp_key = gtk_label_parse_uline (GTK_LABEL (GTK_BIN (html_gallery1)->child),
                                   _("_HTML Gallery"));
  gtk_widget_add_accelerator (html_gallery1, "activate_item", export1_menu_accels,
                              tmp_key, 0, 0);
  gtk_widget_ref (html_gallery1);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "html_gallery1", html_gallery1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (html_gallery1);
  gtk_container_add (GTK_CONTAINER (export1_menu), html_gallery1);
*/
  separator5 = gtk_menu_item_new ();
  gtk_widget_ref (separator5);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "separator5", separator5,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (separator5);
  gtk_container_add (GTK_CONTAINER (file2_menu), separator5);
  gtk_widget_set_sensitive (separator5, FALSE);

  exit1 = gtk_menu_item_new_with_label ("");
  tmp_key = gtk_label_parse_uline (GTK_LABEL (GTK_BIN (exit1)->child),
                                   _("_Exit"));
  gtk_widget_add_accelerator (exit1, "activate_item", file2_menu_accels,
                              tmp_key, 0, 0);
  gtk_widget_ref (exit1);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "exit1", exit1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (exit1);
  gtk_container_add (GTK_CONTAINER (file2_menu), exit1);
  gtk_widget_add_accelerator (exit1, "activate", accel_group,
                              GDK_x, GDK_CONTROL_MASK,
                              GTK_ACCEL_VISIBLE);

  edit1 = gtk_menu_item_new_with_label ("");
  tmp_key = gtk_label_parse_uline (GTK_LABEL (GTK_BIN (edit1)->child),
                                   _("_Edit"));
  gtk_widget_add_accelerator (edit1, "activate_item", accel_group,
                              tmp_key, GDK_MOD1_MASK, 0);
  gtk_widget_ref (edit1);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "edit1", edit1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (edit1);
  gtk_container_add (GTK_CONTAINER (menubar1), edit1);

  edit1_menu = gtk_menu_new ();
  gtk_widget_ref (edit1_menu);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "edit1_menu", edit1_menu,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (edit1), edit1_menu);
  edit1_menu_accels = gtk_menu_ensure_uline_accel_group (GTK_MENU (edit1_menu));

  select1 = gtk_menu_item_new_with_label ("");
  tmp_key = gtk_label_parse_uline (GTK_LABEL (GTK_BIN (select1)->child),
                                   _("_Select"));
  gtk_widget_add_accelerator (select1, "activate_item", accel_group,
                              tmp_key, GDK_MOD1_MASK, 0);
  gtk_widget_ref (select1);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "select1", select1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (select1);
  gtk_container_add (GTK_CONTAINER (menubar1), select1);

  select1_menu = gtk_menu_new ();
  gtk_widget_ref (select1_menu);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "select1_menu", select1_menu,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (select1), select1_menu);
  select1_menu_accels = gtk_menu_ensure_uline_accel_group (GTK_MENU (select1_menu));

  all1 = gtk_menu_item_new_with_label ("");
  tmp_key = gtk_label_parse_uline (GTK_LABEL (GTK_BIN (all1)->child),
                                   _("_All"));
  gtk_widget_add_accelerator (all1, "activate_item", select1_menu_accels,
                              tmp_key, 0, 0);
  gtk_widget_ref (all1);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "all1", all1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (all1);
  gtk_container_add (GTK_CONTAINER (select1_menu), all1);
  gtk_widget_add_accelerator (all1, "activate", accel_group,
                              GDK_a, GDK_SHIFT_MASK,
                              GTK_ACCEL_VISIBLE);

  inverse1 = gtk_menu_item_new_with_label ("");
  tmp_key = gtk_label_parse_uline (GTK_LABEL (GTK_BIN (inverse1)->child),
                                   _("_Inverse"));
  gtk_widget_add_accelerator (inverse1, "activate_item", select1_menu_accels,
                              tmp_key, 0, 0);
  gtk_widget_ref (inverse1);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "inverse1", inverse1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (inverse1);
  gtk_container_add (GTK_CONTAINER (select1_menu), inverse1);
  gtk_widget_add_accelerator (inverse1, "activate", accel_group,
                              GDK_i, GDK_SHIFT_MASK,
                              GTK_ACCEL_VISIBLE);

  none1 = gtk_menu_item_new_with_label ("");
  tmp_key = gtk_label_parse_uline (GTK_LABEL (GTK_BIN (none1)->child),
                                   _("_None"));
  gtk_widget_add_accelerator (none1, "activate_item", select1_menu_accels,
                              tmp_key, 0, 0);
  gtk_widget_ref (none1);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "none1", none1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (none1);
  gtk_container_add (GTK_CONTAINER (select1_menu), none1);
  gtk_widget_add_accelerator (none1, "activate", accel_group,
                              GDK_n, GDK_SHIFT_MASK,
                              GTK_ACCEL_VISIBLE);

  camera1 = gtk_menu_item_new_with_label ("");
  tmp_key = gtk_label_parse_uline (GTK_LABEL (GTK_BIN (camera1)->child),
                                   _("_Camera"));
  gtk_widget_add_accelerator (camera1, "activate_item", accel_group,
                              tmp_key, GDK_MOD1_MASK, 0);
  gtk_widget_ref (camera1);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "camera1", camera1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (camera1);
  gtk_container_add (GTK_CONTAINER (menubar1), camera1);

  camera1_menu = gtk_menu_new ();
  gtk_widget_ref (camera1_menu);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "camera1_menu", camera1_menu,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (camera1), camera1_menu);
  camera1_menu_accels = gtk_menu_ensure_uline_accel_group (GTK_MENU (camera1_menu));

  select2 = gtk_menu_item_new_with_label (_("Select Camera..."));
  gtk_widget_ref (select2);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "select2", select2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (select2);
  gtk_container_add (GTK_CONTAINER (camera1_menu), select2);
  gtk_widget_add_accelerator (select2, "activate", accel_group,
                              GDK_c, GDK_MOD1_MASK,
                              GTK_ACCEL_VISIBLE);

  separator6 = gtk_menu_item_new ();
  gtk_widget_ref (separator6);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "separator6", separator6,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (separator6);
  gtk_container_add (GTK_CONTAINER (camera1_menu), separator6);
  gtk_widget_set_sensitive (separator6, FALSE);

/* 
  download_selected1 = gtk_menu_item_new_with_label ("");
  tmp_key = gtk_label_parse_uline (GTK_LABEL (GTK_BIN (download_selected1)->child),
                                   _("Download _Selected"));
  gtk_widget_add_accelerator (download_selected1, "activate_item", camera1_menu_accels,
                              tmp_key, 0, 0);
  gtk_widget_ref (download_selected1);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "download_selected1", download_selected1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (download_selected1);
  gtk_container_add (GTK_CONTAINER (camera1_menu), download_selected1);

  download_selected1_menu = gtk_menu_new ();
  gtk_widget_ref (download_selected1_menu);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "download_selected1_menu", download_selected1_menu,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (download_selected1), download_selected1_menu);
  download_selected1_menu_accels = gtk_menu_ensure_uline_accel_group (GTK_MENU (download_selected1_menu));

  thumbnails2 = gtk_menu_item_new_with_label ("");
  tmp_key = gtk_label_parse_uline (GTK_LABEL (GTK_BIN (thumbnails2)->child),
                                   _("_Thumbnails"));
  gtk_widget_add_accelerator (thumbnails2, "activate_item", download_selected1_menu_accels,
                              tmp_key, 0, 0);
  gtk_widget_ref (thumbnails2);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "thumbnails2", thumbnails2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (thumbnails2);
  gtk_container_add (GTK_CONTAINER (download_selected1_menu), thumbnails2);
  gtk_widget_add_accelerator (thumbnails2, "activate", accel_group,
                              GDK_t, GDK_MOD1_MASK,
                              GTK_ACCEL_VISIBLE);

  photos1 = gtk_menu_item_new_with_label ("");
  tmp_key = gtk_label_parse_uline (GTK_LABEL (GTK_BIN (photos1)->child),
                                   _("_Photos"));
  gtk_widget_add_accelerator (photos1, "activate_item", download_selected1_menu_accels,
                              tmp_key, 0, 0);
  gtk_widget_ref (photos1);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "photos1", photos1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (photos1);
  gtk_container_add (GTK_CONTAINER (download_selected1_menu), photos1);
  gtk_widget_add_accelerator (photos1, "activate", accel_group,
                              GDK_p, GDK_MOD1_MASK,
                              GTK_ACCEL_VISIBLE);

  both1 = gtk_menu_item_new_with_label ("");
  tmp_key = gtk_label_parse_uline (GTK_LABEL (GTK_BIN (both1)->child),
                                   _("_Both"));
  gtk_widget_add_accelerator (both1, "activate_item", download_selected1_menu_accels,
                              tmp_key, 0, 0);
  gtk_widget_ref (both1);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "both1", both1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (both1);
  gtk_container_add (GTK_CONTAINER (download_selected1_menu), both1);
  gtk_widget_add_accelerator (both1, "activate", accel_group,
                              GDK_b, GDK_MOD1_MASK,
                              GTK_ACCEL_VISIBLE);
*/

  delete1 = gtk_menu_item_new_with_label ("");
  tmp_key = gtk_label_parse_uline (GTK_LABEL (GTK_BIN (delete1)->child),
                                   _("_Delete"));
  gtk_widget_add_accelerator (delete1, "activate_item", camera1_menu_accels,
                              tmp_key, 0, 0);
  gtk_widget_ref (delete1);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "delete1", delete1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (delete1);
  gtk_container_add (GTK_CONTAINER (camera1_menu), delete1);

  delete1_menu = gtk_menu_new ();
  gtk_widget_ref (delete1_menu);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "delete1_menu", delete1_menu,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (delete1), delete1_menu);
  delete1_menu_accels = gtk_menu_ensure_uline_accel_group (GTK_MENU (delete1_menu));

  selected_photos1 = gtk_menu_item_new_with_label ("");
  tmp_key = gtk_label_parse_uline (GTK_LABEL (GTK_BIN (selected_photos1)->child),
                                   _("_Selected Photos"));
  gtk_widget_add_accelerator (selected_photos1, "activate_item", delete1_menu_accels,
                              tmp_key, 0, 0);
  gtk_widget_ref (selected_photos1);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "selected_photos1", selected_photos1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (selected_photos1);
  gtk_container_add (GTK_CONTAINER (delete1_menu), selected_photos1);
  gtk_widget_add_accelerator (selected_photos1, "activate", accel_group,
                              GDK_d, GDK_MOD1_MASK,
                              GTK_ACCEL_VISIBLE);

  all_images1 = gtk_menu_item_new_with_label ("");
  tmp_key = gtk_label_parse_uline (GTK_LABEL (GTK_BIN (all_images1)->child),
                                   _("_All Images"));
  gtk_widget_add_accelerator (all_images1, "activate_item", delete1_menu_accels,
                              tmp_key, 0, 0);
  gtk_widget_ref (all_images1);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "all_images1", all_images1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (all_images1);
  gtk_container_add (GTK_CONTAINER (delete1_menu), all_images1);
  gtk_widget_add_accelerator (all_images1, "activate", accel_group,
                              GDK_a, GDK_MOD1_MASK,
                              GTK_ACCEL_VISIBLE);

  separator3 = gtk_menu_item_new ();
  gtk_widget_ref (separator3);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "separator3", separator3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (separator3);
  gtk_container_add (GTK_CONTAINER (camera1_menu), separator3);
  gtk_widget_set_sensitive (separator3, FALSE);

  configure1 = gtk_menu_item_new_with_label ("");
  tmp_key = gtk_label_parse_uline (GTK_LABEL (GTK_BIN (configure1)->child),
                                   _("_Configure..."));
  gtk_widget_add_accelerator (configure1, "activate_item", camera1_menu_accels,
                              tmp_key, 0, 0);
  gtk_widget_ref (configure1);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "configure1", configure1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (configure1);
  gtk_container_add (GTK_CONTAINER (camera1_menu), configure1);

  information1 = gtk_menu_item_new_with_label ("");
  tmp_key = gtk_label_parse_uline (GTK_LABEL (GTK_BIN (information1)->child),
                                   _("_Information..."));
  gtk_widget_add_accelerator (information1, "activate_item", camera1_menu_accels,
                              tmp_key, 0, 0);
  gtk_widget_ref (information1);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "information1", information1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (information1);
  gtk_container_add (GTK_CONTAINER (camera1_menu), information1);

  manual1 = gtk_menu_item_new_with_label ("");
  tmp_key = gtk_label_parse_uline (GTK_LABEL (GTK_BIN (manual1)->child),
                                   _("_Manual..."));
  gtk_widget_add_accelerator (manual1, "activate_item", camera1_menu_accels,
                              tmp_key, 0, 0);
  gtk_widget_ref (manual1);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "manual1", manual1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (manual1);
  gtk_container_add (GTK_CONTAINER (camera1_menu), manual1);

  about_the_driver1 = gtk_menu_item_new_with_label ("");
  tmp_key = gtk_label_parse_uline (GTK_LABEL (GTK_BIN (about_the_driver1)->child),
                                   _("_About the driver..."));
  gtk_widget_add_accelerator (about_the_driver1, "activate_item", camera1_menu_accels,
                              tmp_key, 0, 0);
  gtk_widget_ref (about_the_driver1);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "about_the_driver1", about_the_driver1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (about_the_driver1);
  gtk_container_add (GTK_CONTAINER (camera1_menu), about_the_driver1);

  help1 = gtk_menu_item_new_with_label ("");
  tmp_key = gtk_label_parse_uline (GTK_LABEL (GTK_BIN (help1)->child),
                                   _("_Help"));
  gtk_widget_add_accelerator (help1, "activate_item", accel_group,
                              tmp_key, GDK_MOD1_MASK, 0);
  gtk_widget_ref (help1);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "help1", help1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (help1);
  gtk_container_add (GTK_CONTAINER (menubar1), help1);

  help1_menu = gtk_menu_new ();
  gtk_widget_ref (help1_menu);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "help1_menu", help1_menu,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (help1), help1_menu);
  help1_menu_accels = gtk_menu_ensure_uline_accel_group (GTK_MENU (help1_menu));

  user_s_manual1 = gtk_menu_item_new_with_label ("");
  tmp_key = gtk_label_parse_uline (GTK_LABEL (GTK_BIN (user_s_manual1)->child),
                                   _("_User's Manual..."));
  gtk_widget_add_accelerator (user_s_manual1, "activate_item", help1_menu_accels,
                              tmp_key, 0, 0);
  gtk_widget_ref (user_s_manual1);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "user_s_manual1", user_s_manual1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (user_s_manual1);
  gtk_container_add (GTK_CONTAINER (help1_menu), user_s_manual1);
/*
  gtk_widget_add_accelerator (user_s_manual1, "activate", accel_group,
                              GDK_m, GDK_CONTROL_MASK,
                              GTK_ACCEL_VISIBLE);
*/
  authors1 = gtk_menu_item_new_with_label ("");
  tmp_key = gtk_label_parse_uline (GTK_LABEL (GTK_BIN (authors1)->child),
                                   _("_Authors..."));
  gtk_widget_add_accelerator (authors1, "activate_item", help1_menu_accels,
                              tmp_key, 0, 0);
  gtk_widget_ref (authors1);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "authors1", authors1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (authors1);
  gtk_container_add (GTK_CONTAINER (help1_menu), authors1);

  license1 = gtk_menu_item_new_with_label ("");
  tmp_key = gtk_label_parse_uline (GTK_LABEL (GTK_BIN (license1)->child),
                                   _("_License..."));
  gtk_widget_add_accelerator (license1, "activate_item", help1_menu_accels,
                              tmp_key, 0, 0);
  gtk_widget_ref (license1);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "license1", license1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (license1);
  gtk_container_add (GTK_CONTAINER (help1_menu), license1);

  about_gphoto1 = gtk_menu_item_new_with_label ("");
  tmp_key = gtk_label_parse_uline (GTK_LABEL (GTK_BIN (about_gphoto1)->child),
                                   _("About _gtKam..."));
  gtk_widget_add_accelerator (about_gphoto1, "activate_item", help1_menu_accels,
                              tmp_key, 0, 0);
  gtk_widget_ref (about_gphoto1);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "about_gphoto1", about_gphoto1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (about_gphoto1);
  gtk_container_add (GTK_CONTAINER (help1_menu), about_gphoto1);
/*
  gtk_widget_add_accelerator (about_gphoto1, "activate", accel_group,
                              GDK_a, GDK_CONTROL_MASK,
                              GTK_ACCEL_VISIBLE);
*/
  toolbar1 = gtk_toolbar_new (GTK_ORIENTATION_HORIZONTAL, GTK_TOOLBAR_ICONS);
  gtk_widget_ref (toolbar1);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "toolbar1", toolbar1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (toolbar1);
  gtk_box_pack_start (GTK_BOX (vbox1), toolbar1, FALSE, FALSE, 0);

/*
  tmp_toolbar_icon = create_pixmap (main_window, "open_image.xpm");
  open_button = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar1),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                _("button1"),
                                NULL, NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_widget_ref (open_button);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "open_button", open_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (open_button);
  tooltip = gtk_tooltips_new();
  gtk_tooltips_set_tip (tooltip, open_button, _("Open a photo"), NULL);
  gtk_signal_connect(GTK_OBJECT(open_button), "clicked", 
	GTK_SIGNAL_FUNC(open_photo), NULL);
*/
  tmp_toolbar_icon = create_pixmap (main_window, "save_current_image.xpm");
  save_button = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar1),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                _("button2"),
                                NULL, NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_widget_ref (save_button);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "save_button", save_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (save_button);
  tooltip = gtk_tooltips_new();
  gtk_tooltips_set_tip (tooltip, save_button, _("Save selected photos"), NULL);
  gtk_signal_connect(GTK_OBJECT(save_button), "clicked", 
	GTK_SIGNAL_FUNC(save_selected_photos), NULL);

  tmp_toolbar_icon = create_pixmap (main_window, "delete_images.xpm");
  delete_button = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar1),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                "Delete",
                                NULL, NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_widget_ref (delete_button);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "delete_button", delete_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (delete_button);
  tooltip = gtk_tooltips_new();
  gtk_tooltips_set_tip (tooltip, delete_button, _("Delete selected photos"), NULL);
  gtk_signal_connect(GTK_OBJECT(delete_button), "clicked", 
	GTK_SIGNAL_FUNC(camera_delete_selected), NULL);

  label2 = gtk_label_new (_("     "));
  gtk_widget_ref (label2);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "label2", label2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label2);
  gtk_toolbar_append_widget (GTK_TOOLBAR (toolbar1), label2, NULL, NULL);

  tmp_toolbar_icon = create_pixmap (main_window, "refresh.xpm");
  refresh_button = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar1),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                _("Refresh"),
                                NULL, NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_widget_ref (refresh_button);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "refresh_button", refresh_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (refresh_button);
  gtk_signal_connect(GTK_OBJECT(refresh_button), "clicked", 
	GTK_SIGNAL_FUNC(folder_refresh), NULL);
  tooltip = gtk_tooltips_new();
  gtk_tooltips_set_tip (tooltip, refresh_button, _("Reload photo index"), NULL);

  label2 = gtk_label_new (_("     "));
  gtk_widget_ref (label2);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "label2", label2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label2);
  gtk_toolbar_append_widget (GTK_TOOLBAR (toolbar1), label2, NULL, NULL);

  tmp_toolbar_icon = create_pixmap (main_window, "configure.xpm");
  configure_button = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar1),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                _("Configure"),
                                NULL, NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_widget_ref (configure_button);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "configure_button", configure_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (configure_button);
  tooltip = gtk_tooltips_new();
  gtk_tooltips_set_tip (tooltip, configure_button, _("Configure the camera"), NULL);
  gtk_signal_connect(GTK_OBJECT(configure_button), "clicked", 
	GTK_SIGNAL_FUNC(camera_configure), NULL);

  label5 = gtk_label_new (_("     "));
  gtk_widget_ref (label5);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "label5", label5,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label5);
  gtk_toolbar_append_widget (GTK_TOOLBAR (toolbar1), label5, NULL, NULL);

  tmp_toolbar_icon = create_pixmap (main_window, "exit.xpm");
  exit_button = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar1),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                _("Exit"),
                                NULL, NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_widget_ref (exit_button);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "exit_button", exit_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_signal_connect(GTK_OBJECT(exit_button), "clicked",
	GTK_SIGNAL_FUNC(main_quit), NULL);
  gtk_widget_show (exit_button);
  tooltip = gtk_tooltips_new();
  gtk_tooltips_set_tip (tooltip, exit_button, _("Exit gtKam"), NULL);

  hpaned1 = gtk_hpaned_new ();
  gtk_widget_ref (hpaned1);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "hpaned1", hpaned1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hpaned1);
  gtk_box_pack_start (GTK_BOX (vbox1), hpaned1, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (hpaned1), 2);
  gtk_paned_set_position (GTK_PANED (hpaned1), 200);

  vbox2 = gtk_vbox_new (FALSE, 5);
  gtk_widget_ref (vbox2);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "vbox2", vbox2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox2);
  gtk_paned_pack1 (GTK_PANED (hpaned1), vbox2, FALSE, TRUE);

/* __main */
  frame = gtk_frame_new(_("Index Settings"));
  gtk_widget_ref (frame);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "settings_frame", frame,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame);
  gtk_box_pack_start (GTK_BOX (vbox2), frame, FALSE, FALSE, 0);
  
  checkbutton = gtk_check_button_new_with_label(_("View Thumbnails"));
  gtk_widget_ref (checkbutton);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "use_thumbs", checkbutton,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (checkbutton);
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(checkbutton), TRUE);
  gtk_container_add (GTK_CONTAINER(frame), checkbutton);

  scrolledwindow1 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_ref (scrolledwindow1);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "scrolledwindow1", scrolledwindow1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow1);
  gtk_box_pack_start (GTK_BOX (vbox2), scrolledwindow1, TRUE, TRUE, 0);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow1), GTK_POLICY_AUTOMATIC, GTK_POLICY_ALWAYS);

  viewport1 = gtk_viewport_new (NULL, NULL);
  gtk_widget_ref (viewport1);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "viewport1", viewport1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (viewport1);
  gtk_container_add (GTK_CONTAINER (scrolledwindow1), viewport1);

  tree1 = gtk_tree_new ();
  gtk_widget_ref (tree1);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "folder_tree", tree1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (tree1);
  gtk_container_add (GTK_CONTAINER (viewport1), tree1);
  gtk_tree_set_selection_mode(GTK_TREE(tree1), GTK_SELECTION_SINGLE);

  tree_item = gtk_tree_item_new ();
  gtk_widget_ref (tree_item);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "camera_tree", tree_item,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_object_set_data (GTK_OBJECT (tree_item), "path", (gpointer)"/");
  gtk_object_set_data (GTK_OBJECT (tree_item), "folder", (gpointer)"/");
  gtk_signal_connect(GTK_OBJECT(tree_item), "select", 
	GTK_SIGNAL_FUNC(folder_set),NULL);
  gtk_signal_connect(GTK_OBJECT(tree_item), "expand", 
	GTK_SIGNAL_FUNC(folder_expand),NULL);
  gtk_widget_show (tree_item);
  gtk_tree_append(GTK_TREE(tree1), tree_item);

  hbox = gtk_hbox_new(FALSE, 3);
  gtk_widget_ref (hbox);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "hbox", hbox,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox);
  gtk_container_add(GTK_CONTAINER(tree_item), hbox);

  pixmap = create_pixmap (main_window, "camera.xpm");
  gtk_widget_ref (pixmap);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "camera_pixmap", pixmap,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pixmap);
  gtk_box_pack_start (GTK_BOX(hbox), pixmap, FALSE, FALSE, 0);

  label = gtk_label_new("No Camera Selected");
  gtk_widget_ref (label);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "camera_label", label,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label);
  gtk_box_pack_start (GTK_BOX(hbox), label, FALSE, FALSE, 0);

  tree1 = gtk_tree_new ();
  gtk_widget_ref (tree1);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "camera_subtree", tree1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (tree1);
  gtk_tree_item_set_subtree(GTK_TREE_ITEM(tree_item), tree1);

  tree_item = gtk_tree_item_new ();
  gtk_widget_ref (tree_item);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "subtree_item", tree_item,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_object_set_data (GTK_OBJECT(tree_item), "blech", "foo");
  gtk_widget_show (tree_item);
  gtk_tree_append(GTK_TREE(tree1), tree_item);

  scrolledwindow2 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_ref (scrolledwindow2);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "scrolledwindow2", scrolledwindow2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow2);
  gtk_paned_pack2 (GTK_PANED (hpaned1), scrolledwindow2, TRUE, TRUE);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow2), GTK_POLICY_NEVER, GTK_POLICY_ALWAYS);

  viewport2 = gtk_viewport_new (NULL, NULL);
  gtk_widget_ref (viewport2);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "viewport2", viewport2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (viewport2);
  gtk_container_add (GTK_CONTAINER (scrolledwindow2), viewport2);

  icons = gtk_icon_list_new(80, GTK_ICON_LIST_TEXT_BELOW);
  gtk_widget_ref (icons);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "icons", icons,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (icons);
  gtk_icon_list_set_selection_mode(GTK_ICON_LIST(icons), GTK_SELECTION_MULTIPLE);
  gtk_container_add (GTK_CONTAINER (viewport2), icons);
  
  status_bar = gtk_statusbar_new ();
  gtk_widget_ref (status_bar);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "status_bar", status_bar,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (status_bar);
  gtk_box_pack_start (GTK_BOX (vbox1), status_bar, FALSE, FALSE, 0);
/*
  gtk_signal_connect (GTK_OBJECT (open3), "activate",
                      GTK_SIGNAL_FUNC (on_open_photo_activate),
                      NULL);
*/
  gtk_signal_connect (GTK_OBJECT (save1), "activate",
                      GTK_SIGNAL_FUNC (on_save_photo_activate),
                      NULL);
/*
  gtk_signal_connect (GTK_OBJECT (html_gallery1), "activate",
                      GTK_SIGNAL_FUNC (on_html_gallery_activate),
                      NULL);
*/
  gtk_signal_connect (GTK_OBJECT (exit1), "activate",
                      GTK_SIGNAL_FUNC (on_exit_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (all1), "activate",
                      GTK_SIGNAL_FUNC (on_select_all_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (inverse1), "activate",
                      GTK_SIGNAL_FUNC (on_select_inverse_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (none1), "activate",
                      GTK_SIGNAL_FUNC (on_select_none_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (select2), "activate",
                      GTK_SIGNAL_FUNC (on_select_camera_activate),
                      NULL);
/*
  gtk_signal_connect (GTK_OBJECT (thumbnails2), "activate",
                      GTK_SIGNAL_FUNC (on_download_thumbnails_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (photos1), "activate",
                      GTK_SIGNAL_FUNC (on_download_photos_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (both1), "activate",
                      GTK_SIGNAL_FUNC (on_download_both_activate),
                      NULL);
*/
  gtk_signal_connect (GTK_OBJECT (selected_photos1), "activate",
                      GTK_SIGNAL_FUNC (on_delete_photos_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (all_images1), "activate",
                      GTK_SIGNAL_FUNC (on_delete_all_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (configure1), "activate",
                      GTK_SIGNAL_FUNC (on_configure_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (information1), "activate",
                      GTK_SIGNAL_FUNC (on_driver_information_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (manual1), "activate",
                      GTK_SIGNAL_FUNC (on_driver_manual_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (about_the_driver1), "activate",
                      GTK_SIGNAL_FUNC (on_driver_about_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (user_s_manual1), "activate",
                      GTK_SIGNAL_FUNC (on_manual_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (authors1), "activate",
                      GTK_SIGNAL_FUNC (on_authors_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (license1), "activate",
                      GTK_SIGNAL_FUNC (on_license_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (about_gphoto1), "activate",
                      GTK_SIGNAL_FUNC (on_about_activate),
                      NULL);

  gtk_window_add_accel_group (GTK_WINDOW (main_window), accel_group);

  return main_window;
}

GtkWidget*
create_message_window_long (void)
{
  /* widget labels:  "message" "close" */
  GtkWidget *message_window_long;
  GtkWidget *vbox3;
  GtkWidget *scrolledwindow4;
  GtkWidget *message_window_text;
  GtkWidget *hsep;
  GtkWidget *message_window_close;

  message_window_long = gtk_window_new (GTK_WINDOW_DIALOG);
  gtk_object_set_data (GTK_OBJECT (message_window_long), "message_window_long", message_window_long);
  gtk_window_set_title (GTK_WINDOW (message_window_long), _("gtKam"));
  gtk_window_set_position (GTK_WINDOW (message_window_long), GTK_WIN_POS_CENTER);
  gtk_window_set_modal (GTK_WINDOW (message_window_long), TRUE);
  gtk_window_set_default_size (GTK_WINDOW (message_window_long), 400, 400);
  gtk_container_set_border_width (GTK_CONTAINER (message_window_long), 5);

  vbox3 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox3);
  gtk_object_set_data_full (GTK_OBJECT (message_window_long), "vbox3", vbox3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox3);
  gtk_container_add (GTK_CONTAINER (message_window_long), vbox3);

  scrolledwindow4 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_ref (scrolledwindow4);
  gtk_object_set_data_full (GTK_OBJECT (message_window_long), "scrolledwindow4", scrolledwindow4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow4);
  gtk_box_pack_start (GTK_BOX (vbox3), scrolledwindow4, TRUE, TRUE, 0);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow4), GTK_POLICY_NEVER, GTK_POLICY_ALWAYS);

  message_window_text = gtk_label_new ("No Message");
  gtk_widget_ref (message_window_text);
  gtk_object_set_data_full (GTK_OBJECT (message_window_long), "message", message_window_text,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (message_window_text);
  gtk_label_set_line_wrap (GTK_LABEL (message_window_text), TRUE);
  gtk_scrolled_window_add_with_viewport (GTK_SCROLLED_WINDOW (scrolledwindow4), 
	message_window_text);

  hsep = gtk_hseparator_new();
  gtk_widget_ref (hsep);
  gtk_object_set_data_full (GTK_OBJECT (message_window_long), "hsep", hsep,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hsep);
  gtk_box_pack_start (GTK_BOX (vbox3), hsep, FALSE, FALSE, 0);

  message_window_close = gtk_button_new_with_label (_("    Close    "));
  gtk_widget_ref (message_window_close);
  gtk_object_set_data_full (GTK_OBJECT (message_window_long), "close", message_window_close,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (message_window_close);
  gtk_box_pack_start (GTK_BOX (vbox3), message_window_close, FALSE, FALSE, 0);

  return message_window_long;
}

GtkWidget*
create_confirm_window (void)
{
  /* widget labels: "message" "yes" "no" */

  GtkWidget *confirm_window;
  GtkWidget *vbox4;
  GtkWidget *confirm_label;
  GtkWidget *hbox2;
  GtkWidget *button19;
  GtkWidget *button20;
  GtkWidget *hsep;

  confirm_window = gtk_window_new (GTK_WINDOW_DIALOG);
  gtk_object_set_data (GTK_OBJECT (confirm_window), "confirm_window", confirm_window);
  gtk_window_set_title (GTK_WINDOW (confirm_window), _("gtKam Confirmation"));
  gtk_window_set_position (GTK_WINDOW (confirm_window), GTK_WIN_POS_CENTER);
  gtk_window_set_modal (GTK_WINDOW (confirm_window), TRUE);
  gtk_window_set_default_size (GTK_WINDOW (confirm_window), 350, 200);
  gtk_container_set_border_width (GTK_CONTAINER (confirm_window), 5);

  vbox4 = gtk_vbox_new (FALSE, 7);
  gtk_widget_ref (vbox4);
  gtk_object_set_data_full (GTK_OBJECT (confirm_window), "vbox", vbox4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox4);
  gtk_container_add (GTK_CONTAINER (confirm_window), vbox4);

  confirm_label = gtk_label_new (_("Are you sure?"));
  gtk_widget_ref (confirm_label);
  gtk_object_set_data_full (GTK_OBJECT (confirm_window), "message", confirm_label,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (confirm_label);
  gtk_box_pack_start (GTK_BOX (vbox4), confirm_label, TRUE, TRUE, 0);

  hsep = gtk_hseparator_new();
  gtk_widget_ref (hsep);
  gtk_object_set_data_full (GTK_OBJECT (confirm_window), "hsep", hsep,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hsep);

  hbox2 = gtk_hbox_new (TRUE, 5);
  gtk_widget_ref (hbox2);
  gtk_object_set_data_full (GTK_OBJECT (confirm_window), "hbox2", hbox2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox2);
  gtk_box_pack_end (GTK_BOX (vbox4), hbox2, FALSE, TRUE, 0);
  gtk_box_pack_end (GTK_BOX (vbox4), hsep, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (hbox2), 5);

  button19 = gtk_button_new_with_label (_("Yes"));
  gtk_widget_ref (button19);
  gtk_object_set_data_full (GTK_OBJECT (confirm_window), "yes", button19,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button19);
  gtk_box_pack_start (GTK_BOX (hbox2), button19, FALSE, TRUE, 0);

  button20 = gtk_button_new_with_label (_("No"));
  gtk_widget_ref (button20);
  gtk_object_set_data_full (GTK_OBJECT (confirm_window), "no", button20,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button20);
  gtk_box_pack_start (GTK_BOX (hbox2), button20, FALSE, TRUE, 0);

  return confirm_window;
}

GtkWidget*
create_message_window (void)
{
  /* widget labels:  "message" "close" */
  GtkWidget *message_window;
  GtkWidget *vbox5;
  GtkWidget *label8;
  GtkWidget *button21;
  GtkWidget *hsep;

  message_window = gtk_window_new (GTK_WINDOW_DIALOG);
  gtk_object_set_data (GTK_OBJECT (message_window), "message_window", message_window);
  gtk_window_set_title (GTK_WINDOW (message_window), _("gtKam"));
  gtk_window_set_position (GTK_WINDOW (message_window), GTK_WIN_POS_CENTER);
  gtk_window_set_modal (GTK_WINDOW (message_window), TRUE);
  gtk_window_set_default_size (GTK_WINDOW (message_window), 350, 200);
  gtk_container_set_border_width (GTK_CONTAINER (message_window), 5);

  vbox5 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox5);
  gtk_object_set_data_full (GTK_OBJECT (message_window), "vbox5", vbox5,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox5);
  gtk_container_add (GTK_CONTAINER (message_window), vbox5);

  label8 = gtk_label_new (_("No message."));
  gtk_widget_ref (label8);
  gtk_object_set_data_full (GTK_OBJECT (message_window), "message", label8,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label8);
  gtk_box_pack_start (GTK_BOX (vbox5), label8, TRUE, TRUE, 0);
  gtk_label_set_line_wrap (GTK_LABEL (label8), TRUE);

  hsep = gtk_hseparator_new();
  gtk_widget_ref (hsep);
  gtk_object_set_data_full (GTK_OBJECT (message_window), "hsep", hsep,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hsep);
  gtk_box_pack_start (GTK_BOX (vbox5), hsep, FALSE, FALSE, 0);

  button21 = gtk_button_new_with_label (_("    Close    "));
  gtk_widget_ref (button21);
  gtk_object_set_data_full (GTK_OBJECT (message_window), "close", button21,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button21);
  gtk_box_pack_start (GTK_BOX (vbox5), button21, FALSE, FALSE, 0);

  return message_window;
}

void message_window_notebook_append(GtkWidget *window, char *label, char *text) {

  GtkWidget *scrolledwindow4, *message_window_text, *label1;
  GtkWidget *notebook = (GtkWidget*)lookup_widget(window, "notebook");

  if (!notebook)
	return;
	
  label1 = gtk_label_new (label);
  gtk_widget_ref (label1);
  gtk_object_set_data_full (GTK_OBJECT (window), "label", label1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label1);

  scrolledwindow4 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_ref (scrolledwindow4);
  gtk_object_set_data_full (GTK_OBJECT (window), "scrolledwindow4", scrolledwindow4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow4);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow4), GTK_POLICY_NEVER, GTK_POLICY_ALWAYS);

  message_window_text = gtk_text_new (NULL, NULL);
  gtk_widget_ref (message_window_text);
  gtk_object_set_data_full (GTK_OBJECT (window), "message", message_window_text,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (message_window_text);
  gtk_text_insert (GTK_TEXT (message_window_text), NULL, &message_window_text->style->black, 
	NULL, text, -1);
  gtk_text_set_editable (GTK_TEXT (message_window_text), FALSE);
  gtk_scrolled_window_add_with_viewport (GTK_SCROLLED_WINDOW (scrolledwindow4), 
	message_window_text);

  gtk_notebook_append_page(GTK_NOTEBOOK(notebook), scrolledwindow4, label1);
}

GtkWidget*
create_message_window_notebook (void)
{
  /* widget labels:  "notebook" "close" */
  GtkWidget *message_window;
  GtkWidget *vbox5;
  GtkWidget *notebook;
  GtkWidget *button21;
  GtkWidget *hsep;

  message_window = gtk_window_new (GTK_WINDOW_DIALOG);
  gtk_object_set_data (GTK_OBJECT (message_window), "message_window", message_window);
  gtk_window_set_title (GTK_WINDOW (message_window), _("gtKam"));
  gtk_window_set_position (GTK_WINDOW (message_window), GTK_WIN_POS_CENTER);
  gtk_window_set_modal (GTK_WINDOW (message_window), TRUE);
  gtk_window_set_default_size (GTK_WINDOW (message_window), 500, 400);
  gtk_container_set_border_width (GTK_CONTAINER (message_window), 5);

  vbox5 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox5);
  gtk_object_set_data_full (GTK_OBJECT (message_window), "vbox5", vbox5,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox5);
  gtk_container_add (GTK_CONTAINER (message_window), vbox5);

  notebook = gtk_notebook_new();
  gtk_widget_ref (notebook);
  gtk_object_set_data_full (GTK_OBJECT (message_window), "notebook", notebook,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (notebook);
  gtk_box_pack_start (GTK_BOX (vbox5), notebook, TRUE, TRUE, 0);

  hsep = gtk_hseparator_new();
  gtk_widget_ref (hsep);
  gtk_object_set_data_full (GTK_OBJECT (message_window), "hsep", hsep,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hsep);
  gtk_box_pack_start (GTK_BOX (vbox5), hsep, FALSE, FALSE, 0);

  button21 = gtk_button_new_with_label (_("    Close    "));
  gtk_widget_ref (button21);
  gtk_object_set_data_full (GTK_OBJECT (message_window), "close", button21,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button21);
  gtk_box_pack_start (GTK_BOX (vbox5), button21, FALSE, FALSE, 0);

  return message_window;
}

GtkWidget*
create_progress_window (void)
{
  /* widget labels:  "message" "progress_bar" "close" */
  GtkWidget *message_window;
  GtkWidget *progress_bar;
  GtkWidget *vbox5;
  GtkWidget *label8;
  GtkWidget *button21;
  GtkWidget *hsep;

  message_window = gtk_window_new (GTK_WINDOW_DIALOG);
  gtk_object_set_data (GTK_OBJECT (message_window), "message_window", message_window);
  gtk_window_set_title (GTK_WINDOW (message_window), _("gtKam Progress"));
  gtk_window_set_position (GTK_WINDOW (message_window), GTK_WIN_POS_CENTER);
  gtk_window_set_modal (GTK_WINDOW (message_window), TRUE);
  gtk_window_set_default_size (GTK_WINDOW (message_window), 350, 200);
  gtk_container_set_border_width (GTK_CONTAINER (message_window), 5);

  vbox5 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox5);
  gtk_object_set_data_full (GTK_OBJECT (message_window), "vbox5", vbox5,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox5);
  gtk_container_add (GTK_CONTAINER (message_window), vbox5);

  label8 = gtk_label_new (_("No message."));
  gtk_widget_ref (label8);
  gtk_object_set_data_full (GTK_OBJECT (message_window), "message", label8,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label8);
  gtk_box_pack_start (GTK_BOX (vbox5), label8, TRUE, TRUE, 0);
  gtk_label_set_line_wrap (GTK_LABEL (label8), TRUE);

  progress_bar = gtk_progress_bar_new ();
  gtk_widget_ref (progress_bar);
  gtk_object_set_data_full (GTK_OBJECT (message_window), "progress_bar", progress_bar,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (progress_bar);
  gtk_box_pack_start (GTK_BOX (vbox5), progress_bar, FALSE, FALSE, 0);

  hsep = gtk_hseparator_new();
  gtk_widget_ref (hsep);
  gtk_object_set_data_full (GTK_OBJECT (message_window), "hsep", hsep,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hsep);
  gtk_box_pack_start (GTK_BOX (vbox5), hsep, FALSE, FALSE, 0);

  button21 = gtk_button_new_with_label (_("    Cancel    "));
  gtk_widget_ref (button21);
  gtk_object_set_data_full (GTK_OBJECT (message_window), "cancel", button21,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button21);
  gtk_box_pack_start (GTK_BOX (vbox5), button21, FALSE, FALSE, 0);
  gtk_signal_connect(GTK_OBJECT(button21), "clicked", 
		GTK_SIGNAL_FUNC(hide_progress_window),NULL);

  return message_window;
}

GtkWidget*
create_message_window_transient (void)
{
  /* widget labels:  "message" */
  GtkWidget *message_window;
  GtkWidget *vbox5;
  GtkWidget *label8;

  message_window = gtk_window_new (GTK_WINDOW_DIALOG);
  gtk_object_set_data (GTK_OBJECT (message_window), "message_window", message_window);
  gtk_window_set_title (GTK_WINDOW (message_window), _("gtKam"));
  gtk_window_set_position (GTK_WINDOW (message_window), GTK_WIN_POS_CENTER);
  gtk_window_set_modal (GTK_WINDOW (message_window), TRUE);
  gtk_window_set_default_size (GTK_WINDOW (message_window), 250, 100);
  gtk_container_set_border_width (GTK_CONTAINER (message_window), 5);

  vbox5 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox5);
  gtk_object_set_data_full (GTK_OBJECT (message_window), "vbox5", vbox5,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox5);
  gtk_container_add (GTK_CONTAINER (message_window), vbox5);

  label8 = gtk_label_new (_("No message."));
  gtk_widget_ref (label8);
  gtk_object_set_data_full (GTK_OBJECT (message_window), "message", label8,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label8);
  gtk_box_pack_start (GTK_BOX (vbox5), label8, TRUE, TRUE, 0);
  gtk_label_set_line_wrap (GTK_LABEL (label8), TRUE);

  return message_window;
}

GtkWidget*
create_select_camera_window (void)
{
  /* widget labels:   "ok" "cancel" "camera" "port" "speed_label" "speed" */

  GtkWidget *select_camera_window;
  GtkWidget *vbox6;
  GtkWidget *hbox5;
  GtkWidget *vbox7;
  GtkWidget *label9;
  GtkWidget *camera_combo;
  GtkWidget *combo_entry1;
  GtkWidget *vbox8;
  GtkWidget *label10;
  GtkWidget *port_combo;
  GtkWidget *combo_entry2;
  GtkWidget *label11;
  GtkWidget *speed_combo;
  GtkWidget *combo_entry3;
  GtkWidget *hbox4;
  GtkWidget *button23;
  GtkWidget *button24;

  select_camera_window = gtk_window_new (GTK_WINDOW_DIALOG);
  gtk_object_set_data (GTK_OBJECT (select_camera_window), "select_camera_window", select_camera_window);
  gtk_window_set_title (GTK_WINDOW (select_camera_window), _("Select Camera"));
  gtk_window_set_position (GTK_WINDOW (select_camera_window), GTK_WIN_POS_CENTER);
  gtk_window_set_modal (GTK_WINDOW (select_camera_window), TRUE);
  gtk_window_set_default_size (GTK_WINDOW (select_camera_window), 300, 150);
  gtk_container_set_border_width(GTK_CONTAINER(select_camera_window), 5);

  vbox6 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox6);
  gtk_object_set_data_full (GTK_OBJECT (select_camera_window), "vbox6", vbox6,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox6);
  gtk_container_add (GTK_CONTAINER (select_camera_window), vbox6);

  hbox5 = gtk_hbox_new (FALSE, 15);
  gtk_widget_ref (hbox5);
  gtk_object_set_data_full (GTK_OBJECT (select_camera_window), "hbox5", hbox5,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox5);
  gtk_box_pack_start (GTK_BOX (vbox6), hbox5, TRUE, TRUE, 0);

  vbox7 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox7);
  gtk_object_set_data_full (GTK_OBJECT (select_camera_window), "vbox7", vbox7,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox7);
  gtk_box_pack_start (GTK_BOX (hbox5), vbox7, TRUE, TRUE, 0);

  label9 = gtk_label_new (_("Select Model:"));
  gtk_widget_ref (label9);
  gtk_object_set_data_full (GTK_OBJECT (select_camera_window), "label9", label9,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label9);
  gtk_box_pack_start (GTK_BOX (vbox7), label9, FALSE, FALSE, 0);
  gtk_misc_set_alignment (GTK_MISC (label9), 0, 0.5);

  camera_combo = gtk_combo_new ();
  gtk_widget_ref (camera_combo);
  gtk_object_set_data_full (GTK_OBJECT (select_camera_window), "camera", camera_combo,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (camera_combo);
  gtk_entry_set_editable(GTK_ENTRY(GTK_COMBO(camera_combo)->entry), FALSE);
  gtk_box_pack_start (GTK_BOX (vbox7), camera_combo, FALSE, FALSE, 0);

  combo_entry1 = GTK_COMBO (camera_combo)->entry;
  gtk_widget_ref (combo_entry1);
  gtk_object_set_data_full (GTK_OBJECT (select_camera_window), "combo_entry1", combo_entry1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (combo_entry1);

  vbox8 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox8);
  gtk_object_set_data_full (GTK_OBJECT (select_camera_window), "vbox8", vbox8,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox8);
  gtk_box_pack_start (GTK_BOX (vbox6), vbox8, TRUE, TRUE, 0);

  label10 = gtk_label_new (_("Select Port:"));
  gtk_widget_ref (label10);
  gtk_object_set_data_full (GTK_OBJECT (select_camera_window), "label10", label10,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label10);
  gtk_box_pack_start (GTK_BOX (vbox8), label10, FALSE, FALSE, 0);
  gtk_misc_set_alignment (GTK_MISC (label10), 0, 0.5);

  port_combo = gtk_combo_new ();
  gtk_widget_ref (port_combo);
  gtk_entry_set_editable(GTK_ENTRY(GTK_COMBO(port_combo)->entry), FALSE);
  gtk_object_set_data_full (GTK_OBJECT (select_camera_window), "port", port_combo,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (port_combo);
  gtk_box_pack_start (GTK_BOX (vbox8), port_combo, FALSE, FALSE, 0);

  combo_entry2 = GTK_COMBO (port_combo)->entry;
  gtk_widget_ref (combo_entry2);
  gtk_object_set_data_full (GTK_OBJECT (select_camera_window), "combo_entry2", combo_entry2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (combo_entry2);

  label11 = gtk_label_new (_("Select Speed:"));
  gtk_widget_ref (label11);
  gtk_object_set_data_full (GTK_OBJECT (select_camera_window), "speed_label", label11,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label11);
  gtk_box_pack_start (GTK_BOX (vbox8), label11, FALSE, FALSE, 0);
  gtk_misc_set_alignment (GTK_MISC (label11), 0, 0.5);

  speed_combo = gtk_combo_new ();
  gtk_widget_ref (speed_combo);
  gtk_entry_set_editable(GTK_ENTRY(GTK_COMBO(speed_combo)->entry), FALSE);
  gtk_object_set_data_full (GTK_OBJECT (select_camera_window), "speed", speed_combo,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (speed_combo);
  gtk_box_pack_start (GTK_BOX (vbox8), speed_combo, FALSE, FALSE, 0);

  combo_entry3 = GTK_COMBO (speed_combo)->entry;
  gtk_widget_ref (combo_entry3);
  gtk_object_set_data_full (GTK_OBJECT (select_camera_window), "combo_entry3", combo_entry3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (combo_entry3);

  hbox4 = gtk_hbox_new (TRUE, 0);
  gtk_widget_ref (hbox4);
  gtk_object_set_data_full (GTK_OBJECT (select_camera_window), "hbox4", hbox4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox4);
  gtk_box_pack_start (GTK_BOX (vbox6), hbox4, FALSE, TRUE, 0);

  button23 = gtk_button_new_with_label (_("OK"));
  gtk_widget_ref (button23);
  gtk_object_set_data_full (GTK_OBJECT (select_camera_window), "ok", button23,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button23);
  gtk_box_pack_start (GTK_BOX (hbox4), button23, FALSE, TRUE, 0);

  button24 = gtk_button_new_with_label (_("Cancel"));
  gtk_widget_ref (button24);
  gtk_object_set_data_full (GTK_OBJECT (select_camera_window), "cancel", button24,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button24);
  gtk_box_pack_start (GTK_BOX (hbox4), button24, FALSE, TRUE, 0);

  return select_camera_window;
}
