/*
 * Initial main.c file generated by Glade. Edit as required.
 * Glade will not overwrite this file.
 */

#ifdef HAVE_CONFIG_H
# include <config.h>
#endif

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <gtk/gtk.h>
#include <gphoto2.h>

#include "callbacks.h"
#include "frontend.h"
#include "interface.h"
#include "support.h"

/* The Globals */
GtkWidget *gp_gtk_main_window		= NULL;
GtkWidget *gp_gtk_progress_window	= NULL;
int	   gp_gtk_debug			= 0;
char	   gp_gtk_camera_model[1024];
int	   gp_gtk_camera_init		= 0;
int	   gp_gtk_old_width		= 640;
Camera*	   gp_gtk_camera 		= NULL;

int
main (int argc, char *argv[])
{
	GtkWidget *label;
	char buf[1024];
	int x, y;

#ifdef ENABLE_NLS
	bindtextdomain (PACKAGE, PACKAGE_LOCALE_DIR);
	textdomain (PACKAGE);
#endif

	gtk_set_locale ();
	gtk_init (&argc, &argv);

	if (argc > 1) {
		if (strcmp(argv[1], "-d")==0)
			gp_gtk_debug = GP_DEBUG_HIGH;
		   else
			gp_gtk_debug = GP_DEBUG_NONE;
	}

	/* Initialize gPhoto2 */
	gp_init(gp_gtk_debug);

	/* Register my callbacks for interaction */
	gp_frontend_register(frontend_status, frontend_progress,
		frontend_message, frontend_confirm, frontend_prompt);

	add_pixmap_directory (PACKAGE_DATA_DIR "/pixmaps");
	add_pixmap_directory (PACKAGE_SOURCE_DIR "/pixmaps");

	gp_gtk_progress_window = create_progress_window();
	gp_gtk_main_window = create_main_window ();
	gtk_widget_show (gp_gtk_main_window);
	gtk_signal_connect(GTK_OBJECT(gp_gtk_main_window), "check_resize",
		GTK_SIGNAL_FUNC(icon_resize), NULL);

	/* Retrieve the last width/height of the window */
        if (gp_setting_get("gtkam", "width", buf)==GP_OK) {
		x = atoi(buf);
		if (gp_setting_get("gtkam", "height", buf)==GP_OK) {
			y = atoi(buf);
		        gdk_window_resize(gp_gtk_main_window->window, x, y);
		}
	}

	gdk_window_get_size(gp_gtk_main_window->window, &x, &y);
	gp_gtk_old_width = x;

	/* Retrieve the last camera used by gtkam */
	if (gp_setting_get("gtkam", "camera", buf)==GP_OK) {
		/* Set the camera model label */
		label = (GtkWidget*) lookup_widget(gp_gtk_main_window, "camera_label");
		gtk_label_set_text(GTK_LABEL(label), buf);
	}

	/* Set the current working directory */
	getcwd(buf, 1024);
	strcat(buf, "/");
	gp_setting_set("gtkam", "cwd", buf);

	gtk_signal_connect (GTK_OBJECT(gp_gtk_main_window), "delete_event",
		GTK_SIGNAL_FUNC(main_quit), NULL);

	if (gp_setting_get("gtkam", "camera", buf)!=GP_OK)
		camera_select();
	
	gtk_main ();
	return 0;
}
